# Common functions used for APC Smart UPS module 
use strict;
use vars qw(%text %config %apcupsd_conf @eprom_cmd %access); 

do '../web-lib.pl'; 
&init_config();  
%access=get_module_acl();

@eprom_cmd=qw(
	SENSITIVITY 
	WAKEUP 
	SLEEP 
	LOTRANSFER 
	HITRANSFER 
	RETURNCHARGE 
	BEEPSTATE 
	UPSNAME );

# read_config(apcd_conf_file)
sub read_config
{
undef(%apcupsd_conf);
my $whatfailed=$text{'alib_cferr'};
if (! -r $_[0]){ &error(&text('alib_failread', $_[0]))};
open(ARFILE, $_[0]) || return 0;
LINE:
while(<ARFILE>) {
  chop;
  if (!/^#/ && /^([^=]+)\s+(.*)$/) {
	if(!$access{'can_edit_eprom'}) {
	  #drop out any eprom params
	  foreach (@eprom_cmd) {next LINE if $1 eq $_;};
	  }
    $apcupsd_conf{$1} = $2;
    }
  }
close(ARFILE);
return \%apcupsd_conf;
}

# modify_param(apcupsd_conf_file,param,oldvalue,newvalue)
sub modify_param
{
my $whatfailed=$text{'alib_cferr'};
if (! -r $_[0]){ &error(&text('alib_failread', $_[0]))};

open(ARFILE, $_[0]) || return 0;
my @aconf=<ARFILE>;
for(my $i=0; $i <= $#aconf; $i++) {
  $aconf[$i] =~ s/^\s*$_[1]\s+$_[2]/$_[1] $_[3]/; 
  }

if (! -w $_[0]){ &error(&text('alib_failwrite', $_[0]))};
open(ARFILE, ">$_[0]")|| return 0;
print ARFILE @aconf;
close(ARFILE);
return 1;
}

#restart service managing through /etc/init.d/ scripts
# restart_service(servicename)
sub restart_service
{
my $whatfailed=$text{'alib_sserr'};
open (OUT,">>/dev/null") or return 0;
&foreign_require("proc", "proc-lib.pl");
if(foreign_check("proc")) {
  &foreign_call("proc", "safe_process_exec", "$config{'stop_cmd'}", "root", "root", *OUT ,*STDIN);
  &foreign_call("proc", "safe_process_exec", "$config{'start_cmd'}", "root", "root", *OUT ,*STDIN);
  }
else {
	&error($text{'alib_fexecerr'});
	return 0;
  }
}
1;
